import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { MsMonitorMetricsTemplate } from '../models/index' 

import {MsMonitorMetricsTemplateItemMU} from './MsMonitorMetricsTemplateItem' 


/**
 * @author auto generate
 * @version 1.0
 * @date 2021-06-22 11:31
 */
interface MsMonitorMetricsTemplateCU extends ConditionUtil<MsMonitorMetricsTemplateCU>{
    ID:FieldUtil<MsMonitorMetricsTemplateCU>;
    CREATE_TIME:FieldUtil<MsMonitorMetricsTemplateCU>;
    UPDATE_TIME:FieldUtil<MsMonitorMetricsTemplateCU>;
    STATE:FieldUtil<MsMonitorMetricsTemplateCU>;
    CODE:FieldUtil<MsMonitorMetricsTemplateCU>;
    NAME:FieldUtil<MsMonitorMetricsTemplateCU>;
    REMARK:FieldUtil<MsMonitorMetricsTemplateCU>;
}

class MsMonitorMetricsTemplateCUImpl extends ConditionUtilImpl<MsMonitorMetricsTemplateCUImpl> implements MsMonitorMetricsTemplateCU{ 
    newInstance(): MsMonitorMetricsTemplateCUImpl {
        return new MsMonitorMetricsTemplateCUImpl();
    } 
    get ID(): FieldUtil<MsMonitorMetricsTemplateCU>{  
        return new FieldUtil('id','id','id', this);
    }
    get CREATE_TIME(): FieldUtil<MsMonitorMetricsTemplateCU>{  
        return new FieldUtil('create_time','createTime','create_time', this);
    }
    get UPDATE_TIME(): FieldUtil<MsMonitorMetricsTemplateCU>{  
        return new FieldUtil('update_time','updateTime','update_time', this);
    }
    get STATE(): FieldUtil<MsMonitorMetricsTemplateCU>{  
        return new FieldUtil('state','state','state', this);
    }
    get CODE(): FieldUtil<MsMonitorMetricsTemplateCU>{  
        return new FieldUtil('code','code','代码', this);
    }
    get NAME(): FieldUtil<MsMonitorMetricsTemplateCU>{  
        return new FieldUtil('name','name','名称', this);
    }
    get REMARK(): FieldUtil<MsMonitorMetricsTemplateCU>{  
        return new FieldUtil('remark','remark','备注', this);
    }
}

@Singleton 
class MsMonitorMetricsTemplateMU extends TableUtilImpl<MsMonitorMetricsTemplateCU,MsMonitorMetricsTemplate>{ 
    tableName  = 'ms_monitor_metrics_template';
    tableFields  = ['id','create_time','update_time','state','code','name','remark'];
    modelFields  = ['id','createTime','updateTime','state','code','name','remark'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [{
            name: 'msMonitorMetricsTemplateItem',
            parentIdFields: [MsMonitorMetricsTemplateMU.ID],
            foreignKeyFields: [MsMonitorMetricsTemplateItemMU.TEMPLATE_ID],
            getTableUtil: ()=>{
                return Container.get(MsMonitorMetricsTemplateItemMU);
            }
        } as SubTable

];

    createConditionUtil(): MsMonitorMetricsTemplateCU {
        return new MsMonitorMetricsTemplateCUImpl();
    }   

    static get ID(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return new FieldUtil('id','id','id', new MsMonitorMetricsTemplateCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return new FieldUtil('create_time','createTime','create_time', new MsMonitorMetricsTemplateCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return new FieldUtil('update_time','updateTime','update_time', new MsMonitorMetricsTemplateCUImpl());
    }
    static get STATE(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return new FieldUtil('state','state','state', new MsMonitorMetricsTemplateCUImpl());
    }
    static get CODE(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return new FieldUtil('code','code','代码', new MsMonitorMetricsTemplateCUImpl());
    }
    static get NAME(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return new FieldUtil('name','name','名称', new MsMonitorMetricsTemplateCUImpl());
    }
    static get REMARK(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return new FieldUtil('remark','remark','备注', new MsMonitorMetricsTemplateCUImpl());
    }

    get ID(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return MsMonitorMetricsTemplateMU.ID;
    }
    get CREATE_TIME(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return MsMonitorMetricsTemplateMU.CREATE_TIME;
    }
    get UPDATE_TIME(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return MsMonitorMetricsTemplateMU.UPDATE_TIME;
    }
    get STATE(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return MsMonitorMetricsTemplateMU.STATE;
    }
    get CODE(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return MsMonitorMetricsTemplateMU.CODE;
    }
    get NAME(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return MsMonitorMetricsTemplateMU.NAME;
    }
    get REMARK(): FieldUtil<MsMonitorMetricsTemplateCU>{ 
        return MsMonitorMetricsTemplateMU.REMARK;
    }
}
export {MsMonitorMetricsTemplateMU, MsMonitorMetricsTemplateCU}
